@{
ystep = get('ystep', 50)
smooth = get('smooth', True)
xticklabelsdivider = get('xticklabelsdivider', 3)

xmax_ = len(xaxis) - 1

xindex = [str(index) for index, _ in enumerate(xaxis)]
xindex = ','.join(xindex)
xticks = [tick for tick in xaxis]

new_xticks = []
for index, xtick in enumerate(xticks):
  if index % xticklabelsdivider == 0:
    new_xticks.append(xtick)
  else:
    new_xticks.append('')

xticks = ','.join(new_xticks)

yticks = [str(value) for value in range(0, ymax, ystep)]
yticks = ','.join(yticks)
}

@{
legends = values[0][0]
for curve in values[1:]:
  legends += ', ' + curve[0]
}

\begin{tikzpicture}
\begin{axis}[
  height=10cm,
  width=\textwidth,
  axis x line=middle,
  axis y line=middle,
  ytick=\empty,
  xtick=\empty,
  extra x ticks={@xindex},
  extra x tick labels={@xticks},
  extra x tick style={
       tick label style={rotate=45, anchor=north east, align=left}
       },
  extra y ticks={@yticks},
  extra y tick labels={@yticks},
  extra y tick style={
       grid=major
       },
  xlabel={},
  ylabel={$k€$},
  xlabel style={below},
  ylabel style={above left},
  xmin=0,
  xmax=@xmax_,
  ymin=0,
  ymax=@ymax,
  legend entries={@legends},
  legend pos=north west,
  legend cell align={left}]

@[for curve in values]
\addlegendimage{black, fill=@curve[2]!50,area legend}
@[end for]

@[for curve, key in zip(values, ['a', 'b', 'c', 'd', 'e', 'f', 'g'])]

@{
backgrounds = []
start = -1
}

\addplot [name path=@key, mark=none, domain=0:100@[if smooth], smooth@[end if]] coordinates {
@[for index, value in enumerate(curve[1])](@index, @value)@{
if start == -1 and value > 0:
  if index > 0:
    start = index - 1
  else:
    start = 0
if start != -1 and value == 0:
  backgrounds.append((start, index))
  start = -1
}
@[end for]
};
@{backgrounds.append((start, index))}

@{
keyaxis = 'axis' + key
}

\path[name path=@keyaxis] (axis cs:0,0) -- (axis cs:@xmax_,0);

@[for background in backgrounds]
\addplot [thick, color=@curve[2], fill=@curve[2], fill opacity=0.5] fill between[of=@key and @keyaxis, soft clip={domain=@background[0]:@background[1]}];
@[end for]

@[end for]

\end{axis}
\end{tikzpicture}
